commit f2b67dce59f512b59fb4684265f07db53a47b670
Author: Phil Krylov <phil@krylov.eu>
Date:   Sun Apr 30 20:05:03 2023 +0200

    U+AB53 LATIN SMALL LETTER CHI (#55114)

diff --git a/sfd/FreeSerif.sfd b/sfd/FreeSerif.sfd
index 8dde01eb..17df0d69 100644
--- a/sfd/FreeSerif.sfd
+++ b/sfd/FreeSerif.sfd
@@ -399197,5 +399197,52 @@ Refer: 3546 567 N 1 0 0 1 0 0 2
 Validated: 1
 EndChar
 
+StartChar: uniAB53
+Encoding: 43859 43859 13478
+Width: 482
+Flags: HW
+AnchorPoint: "bottom-right" 0 -110 basechar 0
+AnchorPoint: "above-right" 0 800 basechar 0
+AnchorPoint: "below" 235 -200 basechar 0
+AnchorPoint: "topright" 336 460 basechar 0
+AnchorPoint: "above" 228 460 basechar 0
+AnchorPoint: "middle" 225 104 basechar 0
+LayerCount: 2
+Fore
+SplineSet
+231 223 m 1
+ 272 320 308 391 308 413 c 0
+ 308 427 298 433 268 435 c 1
+ 268 450 l 1
+ 426 450 l 1
+ 426 435 l 1
+ 394 434 361.150169153 429.204701222 345 391 c 2
+ 252 171 l 1
+ 390 -115 l 2
+ 417.912304688 -170.824609375 421 -185 472 -185 c 1
+ 472 -200 l 1
+ 271 -200 l 1
+ 271 -185 l 1
+ 304 -183 311 -179 311 -161 c 0
+ 311 -155 309 -139 305 -133 c 2
+ 210 77 l 1
+ 135 -116 l 2
+ 122 -136 115 -161 115 -167 c 0
+ 115 -180 127 -185 155 -185 c 1
+ 155 -200 l 1
+ 10 -200 l 1
+ 10 -185 l 1
+ 43 -182 54 -166 83 -124 c 2
+ 187 121 l 1
+ 80 361 l 2
+ 41.9482421875 419.291992188 49.75 434.25 17 435 c 1
+ 17 450 l 1
+ 209 450 l 1
+ 209 435 l 1
+ 179 434 150 433 150 419 c 0
+ 150 406 142.029508197 426.924590164 160 381 c 2
+ 231 223 l 1
+EndSplineSet
+EndChar
 EndChars
 EndSplineFont
diff --git a/sfd/FreeSerifBold.sfd b/sfd/FreeSerifBold.sfd
index bab5e171..db06375a 100644
--- a/sfd/FreeSerifBold.sfd
+++ b/sfd/FreeSerifBold.sfd
@@ -212120,5 +212120,49 @@ Refer: 2155 567 N 1 0 0 1 0 0 2
 Validated: 1
 EndChar
 
+StartChar: uniAB53
+Encoding: 43859 43859 7656
+Width: 482
+Flags: HW
+AnchorPoint: "above-right" 0 800 basechar 0
+AnchorPoint: "topright" 396 473 basechar 0
+AnchorPoint: "above" 270 470 basechar 0
+AnchorPoint: "middle" 282 164 basechar 0
+AnchorPoint: "below" 231 -200 basechar 0
+LayerCount: 2
+Fore
+SplineSet
+282 213 m 1
+ 315 284 356 387 366 413 c 0
+ 371.38468619 427.000184093 358 434 335 435 c 0
+ 332 435 324 436 315 437 c 1
+ 315 461 l 1
+ 483 461 l 1
+ 483 437 l 1
+ 452 432 431.608855246 431.219113497 413 398 c 2
+ 302 162 l 1
+ 460 -156 l 2
+ 469.754076518 -175.631622359 474 -171 490 -176 c 1
+ 490 -200 l 1
+ 249 -200 l 1
+ 249 -176 l 1
+ 280 -174 314 -168 314 -156 c 0
+ 314 -144 262.126953125 -29.296875 250 -1 c 2
+ 232 41 l 1
+ 217 2 149 -125 139 -152 c 0
+ 133.790284663 -166.066231411 153 -174 189 -176 c 1
+ 189 -200 l 1
+ 20 -200 l 1
+ 20 -176 l 1
+ 79 -173 112 -130 214 89 c 5
+ 70 398 l 2
+ 57.3422228875 431.529643628 44 433 18 437 c 1
+ 18 461 l 1
+ 268 461 l 1
+ 268 437 l 1
+ 225 436 216.588867188 428.619140625 211 418 c 0
+ 201 399 264 255 282 213 c 1
+EndSplineSet
+EndChar
 EndChars
 EndSplineFont
diff --git a/sfd/FreeSerifBoldItalic.sfd b/sfd/FreeSerifBoldItalic.sfd
index 6f66032c..77d16586 100644
--- a/sfd/FreeSerifBoldItalic.sfd
+++ b/sfd/FreeSerifBoldItalic.sfd
@@ -91908,5 +91908,43 @@ Refer: 1587 567 N 1 0 0 1 0 0 2
 Validated: 1
 EndChar
 
+StartChar: uniAB53
+Encoding: 43859 43859 4000
+Width: 433
+Flags: HW
+AnchorPoint: "topright" 360 462 basechar 0
+AnchorPoint: "middle" 236 127 basechar 0
+AnchorPoint: "below" 159 -190 basechar 0
+AnchorPoint: "above" 321 449 basechar 0
+LayerCount: 2
+Fore
+SplineSet
+429 348 m 0
+ 408 348 385 368 372 368 c 0
+ 333 368 271 206 264 183 c 1
+ 290 -73 l 2
+ 298 -111 308 -126 327 -126 c 0
+ 345 -126 355 -117 394 -67 c 1
+ 415 -81 l 1
+ 354 -169 312 -203 264 -203 c 0
+ 206 -203 198 -62 189 32 c 1
+ 143 -87 l 2
+ 85 -183 62 -203 12 -203 c 0
+ -26 -203 -52 -179 -52 -144 c 0
+ -52 -113 -28 -88 3 -88 c 0
+ 29 -88 50 -109 64 -109 c 0
+ 81 -109 92 -100 112 -68 c 2
+ 178 112 l 1
+ 148 346 l 2
+ 138 395 124 413 92 413 c 0
+ 83 413 78 413 57 411 c 1
+ 57 438 l 1
+ 224 462 l 5
+ 233 434 241 329 259 244 c 1
+ 299 355 350 462 417 462 c 0
+ 447 462 485 433 485 400 c 0
+ 485 372 459 348 429 348 c 0
+EndSplineSet
+EndChar
 EndChars
 EndSplineFont
diff --git a/sfd/FreeSerifItalic.sfd b/sfd/FreeSerifItalic.sfd
index d3827308..fe07ecdd 100644
--- a/sfd/FreeSerifItalic.sfd
+++ b/sfd/FreeSerifItalic.sfd
@@ -129070,5 +129070,45 @@ Refer: 1647 567 N 1 0 0 1 0 0 2
 Validated: 1
 EndChar
 
+StartChar: uniAB53
+Encoding: 43859 43859 5105
+Width: 435
+Flags: HW
+AnchorPoint: "topright" 350 442 basechar 0
+AnchorPoint: "below" 146 -190 basechar 0
+AnchorPoint: "above" 284 443 basechar 0
+AnchorPoint: "middle" 219 153 basechar 0
+LayerCount: 2
+Fore
+SplineSet
+291 -146 m 0
+ 309 -146 310 -134 359 -79 c 1
+ 373 -87 l 1
+ 315 -177 289 -201 251 -201 c 0
+ 219 -201 206 -185 193 -134 c 2
+ 183 96 l 1
+ 58 -117 26 -201 -40 -201 c 0
+ -70 -201 -90 -185 -90 -159 c 0
+ -90 -139 -75 -124 -56 -124 c 0
+ -33 -124 -13.944967635 -151.352125904 2 -143 c 0
+ 23 -132 78 -34 99 5 c 0
+ 179 156 l 1
+ 166 335 l 2
+ 163.39612497 393.731847905 168 404 121 404 c 0
+ 112 404 103 402 65 393 c 1
+ 61 408 l 1
+ 72 412 l 2
+ 133 432 167 441 189 441 c 0
+ 216 441 238 431 238 363 c 2
+ 238 238 l 1
+ 327 385 359 441 403 441 c 0
+ 427 441 444 425 444 404 c 0
+ 444 383 430 368 409 368 c 0
+ 389 368 376 385 358 385 c 0
+ 340 385 284 261 240 184 c 1
+ 240 164 250 -66 260 -105 c 0
+ 267 -133 276 -146 291 -146 c 0
+EndSplineSet
+EndChar
 EndChars
 EndSplineFont